#include <stdio.h>
#include <stdlib.h>
#include "catmull_rom.h"
int main()
{
   Points_t data_points[] =
   {
      {0, 1.5}, {2, 2}, {3, 1}, {4, 0.5}, {5, 1}, {6, 2}, {7, 3},{8,4},{5,4},{4,4},{2,2.5},
      {4,2},{4,3},{2,4},{0,0},
      {-100,-100}
   };
   // in this example, we determine the size of the data array by search for the
   // end sentinel {-100,-100}
   int n = 0;
   while (data_points[n].x != -100 && data_points[n].y != -100)
      n++;
   printf("Number of data points:                %d\n",n);
   int NUM_POINTS = 100; // Density of chain data_points
			 // i.e. the number of data_points to interpolate between two datapoints
   // m will be the size of the array that will contain the interpolated values
   int m = (n-3) * NUM_POINTS;

   printf("Number of interpolated spline points: %d\n",m);
   // chain_points will receive the interpolated data
   Points_t *chain_points = (Points_t*) malloc(m*sizeof(Points_t));

   // compute the catmull_rom spline:
   catmull_rom_chain(data_points, n, NUM_POINTS, chain_points, 1);

   FILE *f = fopen("spline.txt","w");
   // output spline x-y values
   for(int i =0; i<m; i++)
      fprintf(f,"%g %g\n",chain_points[i].x,chain_points[i].y);
   fclose(f);
   f = fopen("datapoints.txt","w");
   for (int i=0; i<n; i++)
      fprintf(f,"%g %g\n",data_points[i].x,data_points[i].y);
   fclose(f);

   printf("Data points are in 'datapoints.txt'.\n");
   printf("Interpolated points in 'spline.txt'.\n");
   free(chain_points);
}

